AzerothAdventureAlbum = {};

local function InitializeDB()
    AAASettings = AAASettings or {};
    AAASettings["Sound"] = AAASettings["Sound"] or true
    AAASettings["Darken Background"] = AAASettings["Darken Background"] or true
    if AAASettings["Minimap"] == nil then
        AAASettings["Minimap"] = true;
    end
    if AAASettings["Little Things"] == nil then
        AAASettings["Little Things"] = true;
    end
    if AAASettings["Night Mode"] == nil then
        AAASettings["Night Mode"] = true;
    end
    AAASettings["MinimapAngle"] = AAASettings["MinimapAngle"] or 35
    AAASettings["Pin Style"] = AAASettings["Pin Style"] or 1
    AAASettings["Current Version"] = AAASettings["Current Version"] or 100
    AAASettings["GlobalScale"] = AAASettings["GlobalScale"] or 1;

    --Progress
    AzerothAdventureAlbumProgress = AzerothAdventureAlbumProgress or {};
    if not AzerothAdventureAlbumProgress.Titans then
        AzerothAdventureAlbumProgress.Titans = {};
    end
    if not AzerothAdventureAlbumProgress.TidesofV then
        AzerothAdventureAlbumProgress.TidesofV = {};
    end

    if Progress and type(Progress) == "table" then
        if Progress.Titans then
            for i = 1, #Progress do
                AzerothAdventureAlbumProgress[i] = Progress[i];
            end
            for i = 1, #Progress.Titans do
                AzerothAdventureAlbumProgress.Titans[i] = Progress.Titans[i];
            end
        end
        if Progress.TidesofV then
            for i = 1, #Progress.TidesofV do
                AzerothAdventureAlbumProgress.TidesofV[i] = Progress.TidesofV[i];
            end
        end
    end
end

local LoadProgress = CreateFrame("Frame")

LoadProgress:RegisterEvent("PLAYER_ENTERING_WORLD");

LoadProgress:SetScript("OnEvent",function(self, event, ...)
    self:UnregisterEvent("PLAYER_ENTERING_WORLD");
    InitializeDB();
    local Progress = AzerothAdventureAlbumProgress;
    local Travel = AzerothAdventureAlbum.Travel;
    for i = 1, #Travel do
        Progress[i] = Progress[i] or false;
        if (Travel[i]["Status"]) == false then
            Travel[i]["Status"] = Progress[i];
        end
    end

    local Titans = AzerothAdventureAlbum.Titans;
    for i = 1, #Titans do
        Progress.Titans[i] = Progress.Titans[i] or false;
        if (Titans[i]["Status"]) == false then
            Titans[i]["Status"] = Progress["Titans"][i];
        end
    end

    local TidesofV = AzerothAdventureAlbum.TidesofV;
    for i = 1, #TidesofV do
        Progress.TidesofV[i] = Progress.TidesofV[i] or false;
        if (TidesofV[i]["Status"]) == false then
            TidesofV[i]["Status"] = Progress["TidesofV"][i];
        end
    end
end)
    